-- ------------------------------------------------------------------------------ --
--                                TradeSkillMaster                                --
--                http://www.curse.com/addons/wow/tradeskill-master               --
--                                                                                --
--             A TradeSkillMaster Addon (http://tradeskillmaster.com)             --
--    All Rights Reserved* - Detailed license information included with addon.    --
-- ------------------------------------------------------------------------------ --

local _, TSM = ...
local Prospect = TSM.Init("Data.Prospect")
local private = {}



-- ============================================================================
-- Prospect Data
-- ============================================================================

local DATA = TSM.IsWowClassic() and {} or {
	-- ======================================== Vanilla Gems =======================================
	["i:774"] = { -- Malachite
		["i:2770"] = 0.1,
	},
	["i:818"] = { -- Tigerseye
		["i:2770"] = 0.1,
	},
	["i:1210"] = {  -- Shadowgem
		["i:2771"] = 0.08,
		["i:2770"] = 0.02,
	},
	["i:1206"] = { -- Moss Agate
		["i:2771"] = 0.06,
	},
	["i:1705"] = { -- Lesser Moonstone
		["i:2771"] = 0.08,
		["i:2772"] = 0.06,
	},
	["i:1529"] = { -- Jade
		["i:2772"] = 0.08,
		["i:2771"] = 0.006,
	},
	["i:3864"] = { -- Citrine
		["i:2772"] = 0.08,
		["i:3858"] = 0.06,
		["i:2771"] = 0.006,
	},
	["i:7909"] = { -- Aquamarine
		["i:3858"] = 0.06,
		["i:2772"] = 0.01,
		["i:2771"] = 0.006,
	},
	["i:7910"] = { -- Star Ruby
		["i:3858"] = 0.08,
		["i:10620"] = 0.02,
		["i:2772"] = 0.01,
	},
	["i:12361"] = { -- Blue Sapphire
		["i:10620"] = 0.06,
		["i:3858"] = 0.006,
	},
	["i:12799"] = { -- Large Opal
		["i:10620"] = 0.06,
		["i:3858"] = 0.006,
	},
	["i:12800"] = { -- Azerothian Diamond
		["i:10620"] = 0.06,
		["i:3858"] = 0.004,
	},
	["i:12364"] = { -- Huge Emerald
		["i:10620"] = 0.06,
		["i:3858"] = 0.004,
	},
	-- ======================================== Uncommon Gems ======================================
	["i:23117"] = { -- Azure Moonstone
		["i:23424"] = 0.04,
		["i:23425"] = 0.04,
	},
	["i:23077"] = { -- Blood Garnet
		["i:23424"] = 0.04,
		["i:23425"] = 0.04,
	},
	["i:23079"] = { -- Deep Peridot
		["i:23424"] = 0.04,
		["i:23425"] = 0.04,
	},
	["i:21929"] = { -- Flame Spessarite
		["i:23424"] = 0.04,
		["i:23425"] = 0.04,
	},
	["i:23112"] = { -- Golden Draenite
		["i:23424"] = 0.04,
		["i:23425"] = 0.04,
	},
	["i:23107"] = { -- Shadow Draenite
		["i:23424"] = 0.04,
		["i:23425"] = 0.04,
	},
	["i:36917"] = { -- Bloodstone
		["i:36909"] = 0.05,
		["i:36912"] = 0.04,
		["i:36910"] = 0.05,
	},
	["i:36923"] = { -- Chalcedony
		["i:36909"] = 0.05,
		["i:36912"] = 0.04,
		["i:36910"] = 0.05,
	},
	["i:36932"] = { -- Dark Jade
		["i:36909"] = 0.05,
		["i:36912"] = 0.04,
		["i:36910"] = 0.05,
	},
	["i:36929"] = { -- Huge Citrine
		["i:36909"] = 0.05,
		["i:36912"] = 0.04,
		["i:36910"] = 0.05,
	},
	["i:36926"] = { -- Shadow Crystal
		["i:36909"] = 0.05,
		["i:36912"] = 0.04,
		["i:36910"] = 0.05,
	},
	["i:36920"] = { -- Sun Crystal
		["i:36909"] = 0.05,
		["i:36912"] = 0.04,
		["i:36910"] = 0.04,
	},
	["i:52182"] = { -- Jasper
		["i:53038"] = 0.05,
		["i:52185"] = 0.04,
		["i:52183"] = 0.04,
	},
	["i:52180"] = { -- Nightstone
		["i:53038"] = 0.05,
		["i:52185"] = 0.04,
		["i:52183"] = 0.04,
	},
	["i:52178"] = { -- Zephyrite
		["i:53038"] = 0.05,
		["i:52185"] = 0.04,
		["i:52183"] = 0.04,
	},
	["i:52179"] = { -- Alicite
		["i:53038"] = 0.05,
		["i:52185"] = 0.04,
		["i:52183"] = 0.04,
	},
	["i:52177"] = { -- Carnelian
		["i:53038"] = 0.05,
		["i:52185"] = 0.04,
		["i:52183"] = 0.04,
	},
	["i:52181"] = { -- Hessonite
		["i:53038"] = 0.05,
		["i:52185"] = 0.04,
		["i:52183"] = 0.04,
	},
	["i:76130"] = { -- Tiger Opal
		["i:72092"] = 0.05,
		["i:72093"] = 0.05,
		["i:72103"] = 0.04,
		["i:72094"] = 0.04,
	},
	["i:76133"] = { -- Lapis Lazuli
		["i:72092"] = 0.05,
		["i:72093"] = 0.05,
		["i:72103"] = 0.04,
		["i:72094"] = 0.04,
	},
	["i:76134"] = { -- Sunstone
		["i:72092"] = 0.05,
		["i:72093"] = 0.05,
		["i:72103"] = 0.04,
		["i:72094"] = 0.04,
	},
	["i:76135"] = { -- Roguestone
		["i:72092"] = 0.05,
		["i:72093"] = 0.05,
		["i:72103"] = 0.04,
		["i:72094"] = 0.04,
	},
	["i:76136"] = { -- Pandarian Garnet
		["i:72092"] = 0.05,
		["i:72093"] = 0.05,
		["i:72103"] = 0.04,
		["i:72094"] = 0.04,
	},
	["i:76137"] = { -- Alexandrite
		["i:72092"] = 0.05,
		["i:72093"] = 0.05,
		["i:72103"] = 0.04,
		["i:72094"] = 0.04,
	},
	["i:130172"] = { -- Sangrite
		["i:123918"] = 0.007,
		["i:123919"] = 0.022,
	},
	["i:130173"] = { -- Deep Amber
		["i:123918"] = 0.011,
		["i:123919"] = 0.042,
	},
	["i:130174"] = { -- Azsunite
		["i:123918"] = 0.012,
		["i:123919"] = 0.043,
	},
	["i:130175"] = { -- Chaotic Spinel
		["i:123918"] = 0.006,
		["i:123919"] = 0.021,
	},
	["i:130176"] = { -- Skystone
		["i:123918"] = 0.012,
		["i:123919"] = 0.04,
	},
	["i:130177"] = { -- Queen's Opal
		["i:123918"] = 0.012,
		["i:123919"] = 0.045,
	},
	["i:129100"] = { -- Gem Chip - mostly trash but limited use in some professions
		["i:123918"] = 0.2,
		["i:123919"] = 0.2,
	},
	["i:153700"] = { -- Golden Beryl - BFA
		["i:152579"] = 0.06,
		["i:152512"] = 0.055,
		["i:152513"] = 0.065,
	},
	["i:153701"] = { -- Rubellite - BFA
		["i:152579"] = 0.06,
		["i:152512"] = 0.055,
		["i:152513"] = 0.065,
	},
	["i:153702"] = { -- Kubiline - BFA
		["i:152579"] = 0.06,
		["i:152512"] = 0.055,
		["i:152513"] = 0.065,
	},
	["i:153703"] = { -- Solstone - BFA
		["i:152579"] = 0.06,
		["i:152512"] = 0.055,
		["i:152513"] = 0.065,
	},
	["i:153704"] = { -- Viridium - BFA
		["i:152579"] = 0.06,
		["i:152512"] = 0.055,
		["i:152513"] = 0.065,
	},
	["i:153705"] = { -- Kyanite - BFA
		["i:152579"] = 0.06,
		["i:152512"] = 0.055,
		["i:152513"] = 0.065,
	},
	-- ========================================== Rare Gems ========================================
	["i:23440"] = { -- Dawnstone
		["i:23424"] = 0.002,
		["i:23425"] = 0.008,
	},
	["i:23436"] = { -- Living Ruby
		["i:23424"] = 0.002,
		["i:23425"] = 0.008,
	},
	["i:23441"] = { -- Nightseye
		["i:23424"] = 0.002,
		["i:23425"] = 0.008,
	},
	["i:23439"] = { -- Noble Topaz
		["i:23424"] = 0.002,
		["i:23425"] = 0.008,
	},
	["i:23438"] = { -- Star of Elune
		["i:23424"] = 0.002,
		["i:23425"] = 0.008,
	},
	["i:23437"] = { -- Talasite
		["i:23424"] = 0.002,
		["i:23425"] = 0.008,
	},
	["i:36921"] = { -- Autumn's Glow
		["i:36909"] = 0.002,
		["i:36912"] = 0.008,
		["i:36910"] = 0.008,
	},
	["i:36933"] = { -- Forest Emerald
		["i:36909"] = 0.002,
		["i:36912"] = 0.008,
		["i:36910"] = 0.008,
	},
	["i:36930"] = { -- Monarch Topaz
		["i:36909"] = 0.002,
		["i:36912"] = 0.008,
		["i:36910"] = 0.008,
	},
	["i:36918"] = { -- Scarlet Ruby
		["i:36909"] = 0.002,
		["i:36912"] = 0.008,
		["i:36910"] = 0.008,
	},
	["i:36924"] = { -- Sky Sapphire
		["i:36909"] = 0.002,
		["i:36912"] = 0.008,
		["i:36910"] = 0.008,
	},
	["i:36927"] = { -- Twilight Opal
		["i:36909"] = 0.002,
		["i:36912"] = 0.008,
		["i:36910"] = 0.008,
	},
	["i:52192"] = { -- Dream Emerald
		["i:53038"] = 0.016,
		["i:52185"] = 0.01,
		["i:52183"] = 0.008,
	},
	["i:52193"] = { -- Ember Topaz
		["i:53038"] = 0.016,
		["i:52185"] = 0.01,
		["i:52183"] = 0.008,
	},
	["i:52190"] = { -- Inferno Ruby
		["i:53038"] = 0.016,
		["i:52185"] = 0.01,
		["i:52183"] = 0.008,
	},
	["i:52195"] = { -- Amberjewel
		["i:53038"] = 0.016,
		["i:52185"] = 0.01,
		["i:52183"] = 0.008,
	},
	["i:52194"] = { -- Demonseye
		["i:53038"] = 0.016,
		["i:52185"] = 0.01,
		["i:52183"] = 0.008,
	},
	["i:52191"] = { -- Ocean Sapphire
		["i:53038"] = 0.016,
		["i:52185"] = 0.01,
		["i:52183"] = 0.008,
	},
	["i:76131"] = { -- Primordial Ruby
		["i:72092"] = 0.008,
		["i:72093"] = 0.008,
		["i:72103"] = 0.03,
		["i:72094"] = 0.03,
	},
	["i:76138"] = { -- River's Heart
		["i:72092"] = 0.008,
		["i:72093"] = 0.008,
		["i:72103"] = 0.03,
		["i:72094"] = 0.03,
	},
	["i:76139"] = { -- Wild Jade
		["i:72092"] = 0.008,
		["i:72093"] = 0.008,
		["i:72103"] = 0.03,
		["i:72094"] = 0.03,
	},
	["i:76140"] = { -- Vermillion Onyx
		["i:72092"] = 0.008,
		["i:72093"] = 0.008,
		["i:72103"] = 0.03,
		["i:72094"] = 0.03,
	},
	["i:76141"] = { -- Imperial Amethyst
		["i:72092"] = 0.008,
		["i:72093"] = 0.008,
		["i:72103"] = 0.03,
		["i:72094"] = 0.03,
	},
	["i:76142"] = { -- Sun's Radiance
		["i:72092"] = 0.008,
		["i:72093"] = 0.008,
		["i:72103"] = 0.03,
		["i:72094"] = 0.03,
	},
	["i:130178"] = { -- FuryStone
		["i:123918"] = 0.001,
		["i:123919"] = 0.005,
	},
	["i:130179"] = { -- Eye of Prophecy
		["i:123918"] = 0.002,
		["i:123919"] = 0.007,
	},
	["i:130180"] = { -- Dawnlight
		["i:123918"] = 0.002,
		["i:123919"] = 0.007,
	},
	["i:130181"] = { -- Pandemonite
		["i:123918"] = 0.001,
		["i:123919"] = 0.003,
	},
	["i:130182"] = { -- Maelstrom Sapphire
		["i:123918"] = 0.002,
		["i:123919"] = 0.007,
	},
	["i:130183"] = { -- Shadowruby
		["i:123918"] = 0.002,
		["i:123919"] = 0.006,
	},
	["i:154120"] = { -- Owlseye - BFA
		["i:152579"] = 0.015,
		["i:152512"] = 0.0085,
		["i:152513"] = 0.0235,
	},
	["i:154121"] = { -- Scarlet Diamond - BFA
		["i:152579"] = 0.015,
		["i:152512"] = 0.0085,
		["i:152513"] = 0.0235,
	},
	["i:154122"] = { -- Tidal Amethyst - BFA
		["i:152579"] = 0.015,
		["i:152512"] = 0.0085,
		["i:152513"] = 0.0235,
	},
	["i:154123"] = { -- Amberblaze - BFA
		["i:152579"] = 0.015,
		["i:152512"] = 0.0085,
		["i:152513"] = 0.0235,
	},
	["i:154124"] = { -- Laribole - BFA
		["i:152579"] = 0.015,
		["i:152512"] = 0.0085,
		["i:152513"] = 0.0235,
	},
	["i:154125"] = { -- Royal Quartz - BFA
		["i:152579"] = 0.015,
		["i:152512"] = 0.0085,
		["i:152513"] = 0.0235,
	},
	-- ========================================== Epic Gems ========================================
	["i:151579"] = { -- Labradorite
		["i:151564"] = 0.0056,
	},
	["i:151719"] = { -- Lightsphene
		["i:151564"] = 0.0064,
	},
	["i:151718"] = { -- Argulite
		["i:151564"] = 0.0060,
	},
	["i:151720"] = { -- Chemirine
		["i:151564"] = 0.0063,
	},
	["i:151722"] = { -- Florid Malachite
		["i:151564"] = 0.0035,
	},
	["i:151721"] = { -- Hesselian
		["i:151564"] = 0.0040,
	},
	["i:153706"] = { -- Kraken's Eye - BFA
		["i:152579"] = 0.0065,
		["i:152512"] = 0.006,
		["i:152513"] = 0.0081,
	},
	["i:168635"] = { -- Leviathan's Eye - BFA
		["i:168185"] = 0.032,
	},
	["i:168188"] = { -- Sage Agate - BFA
		["i:168185"] = 0.012,
	},
	["i:168193"] = { -- Azsharine - BFA
		["i:168185"] = 0.012,
	},
	["i:168189"] = { -- Dark Opal - BFA
		["i:168185"] = 0.04,
	},
	["i:168190"] = { -- Lava Lazuli - BFA
		["i:168185"] = 0.044,
	},
	["i:168191"] = { -- Sea Currant - BFA
		["i:168185"] = 0.044,
	},
	["i:168192"] = { -- Sand Spinel - BFA
		["i:168185"] = 0.044,
	},
}



-- ============================================================================
-- Module Functions
-- ============================================================================

function Prospect.TargetItemIterator()
	return private.TableKeyIterator, DATA, nil
end

function Prospect.SourceItemIterator(targetItemString)
	return private.TableKeyIterator, DATA[targetItemString], nil
end

function Prospect.GetRate(targetItemString, sourceItemString)
	return DATA[targetItemString][sourceItemString]
end



-- ============================================================================
-- Private Helper Functions
-- ============================================================================

function private.TableKeyIterator(tbl, index)
	index = next(tbl, index)
	return index
end
